=begin
名称：AN_key_roitx(键盘轴向旋转)
作者：星野传说
日期：2015.01.25
版本：v1.0
版权：星野传说的博客 http://blog.sina.com.cn/apex168
使用说明：
键盘轴向旋转：移动鼠标启动组或组件，↑X旋转，←X旋转，→Z旋转，↓回转，VCB修变角度值Enter确认
启动组件后按住SHIFT可将鼠标移开悬停，鼠标键点击组件依当前轴向旋转。
其它说明：
此插件主要用于快速以组件轴心旋转之用，用于置放组件后快速利用键盘来操作旋转。
启动插件默认为Y轴，角度45度。



=end
module AN_Hoshino_TOOL
  module HoshinoTOOL
   class AN_key_roitx

  # 在初始化启动工具
  def activate 
    model=Sketchup.active_model  #------------------------------回传=>模型中启动的实例
	model.start_operation("键盘旋转") #--------------------模型启动运行 插件
    @entities = []
    # 显示VCB和状态信息
    Sketchup::set_status_text("键盘旋转：移动鼠标启动组或组件(按住Shift多选)，↑X旋转，←X旋转，→Z旋转，↓回转，VCB修变角度值Enter确认,Esc退出", SB_PROMPT)
    Sketchup::set_status_text("Z轴，角度：", SB_VCB_LABEL)
    @v = Geom::Vector3d.new(0,0,1)
    # 默认值
	@angle =nil
	angle  =Sketchup.read_default('ankeyroitx', 'angle')
	@angle = angle.to_i unless angle==nil
    @angle = 45 unless @angle
    @add_selection = 0
  end
      #执行旋转
  def rotate(v_xyz, angle)
    ss= Sketchup.active_model.selection
	if v_xyz=="x"
	     Sketchup::set_status_text("X轴，角度：", SB_VCB_LABEL)
		 @v = Geom::Vector3d.new(1,0,0)
	end
	if v_xyz=="y"
	     Sketchup::set_status_text("Y轴，角度：", SB_VCB_LABEL)
		 @v = Geom::Vector3d.new(0,1,0)
	end
	if v_xyz=="z"
	     Sketchup::set_status_text("Z轴，角度：", SB_VCB_LABEL)
		 @v = Geom::Vector3d.new(0,0,1)
	end
	if v_xyz=="v"
	   angle=-angle
	end
    ss.each do |e|  
      #pt = e.bounds.origin(中心)
      pt = e.transformation.origin#(原点)
      tr = Geom::Transformation.rotation(pt,@v,angle.degrees)
      Sketchup.active_model.active_entities.transform_entities(tr,e)
    end
  end


  # 在鼠标移动进行选择
  def onMouseMove(flags, x, y, view)  
    Sketchup::set_status_text("#{@angle}", SB_VCB_VALUE)
    ph = view.pick_helper
    found = ph.do_pick(x,y)
    picked = ph.best_picked 

    if (picked != nil)
      # 不添加边缘/面孔选择
      if (!picked.kind_of? Sketchup::Edge and !picked.kind_of? Sketchup::Face)
	Sketchup.active_model.selection.add(picked) if (picked != @entities)
	@entities = picked
      end
    else
      if @add_selection == 0
	Sketchup.active_model.selection.clear
	@entities = nil
      end
    end
  end
  
  # 随机旋转(鼠标左键)
  def onLButtonDown(flags, x, y, view) 
    #@angle = rand(360)
    # 更新VCB值
    #Sketchup::set_status_text("#{@angle}", SB_VCB_VALUE)
    rotate(@angle)
  end
  
  # 如果SHIFT被释放回正常选择（启动组件后按住SHIFT可将鼠标移开悬停）
  def onKeyUp(key, repeat, flags, view)
    @add_selection = 0 if key == CONSTRAIN_MODIFIER_KEY
  end
  
  # 键盘操作
  def onKeyDown(key, repeat, flags, view)
    case key
    when VK_UP    then rotate("x", @angle)         #↑键	
    when VK_LEFT  then rotate("y", @angle)         #←键
    when VK_RIGHT then rotate("z", @angle)         #→键
    when VK_DOWN  then rotate("v", @angle)         #↓键
   #when COPY_MODIFIER_KEY then change_axis_up  #COPY_MODIFIER_KEY = Ctrl键
   #when VK_END then change_axis_down           #End键
    when CONSTRAIN_MODIFIER_KEY then @add_selection = 1 if (repeat == 1)#CONSTRAIN MODIFIER KEY 限制修改(Enter)键
    end
  end
  
  # 在VCB修改用户的角度文
  def onUserText(text,view)
    begin
      value = text.to_i
    rescue
      # 错误解析文本
      UI.beep
      value = nil
      Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value
    @angle = value
	Sketchup.write_default('ankeyroitx', 'angle', "#{@angle.to_s}")
  end
  
  def onCancel(flags,view)#====================================================取消
     Sketchup.send_action "selectSelectionTool:"#-----------------------------SketchUp的发送行为选择选择工具
	 model.commit_operation  #模型提交操作
     #return nil
  end#-------------------------------------------------------------------------结束
  
 end # 分类结束
 end #Hoshino_TOOL
end #AN_Hoshino_TOOL

=begin
#---------------------------添加菜单项--------------------------------------
if( not $key_rotix_menu_loaded )
  add_separator_to_menu("Plugins")
  UI.menu("Plugins").add_item("键盘旋转") { Sketchup.active_model.select_tool HoshinoTOOL::AN_key_roitx.new }
end

$key_rotix_menu_loaded = true 
=end
