=begin
# --------------------轴向变形---------------------- #
作者：星野传说
文件名：AN_vector_to_deformatio
中文名称：轴向变形
日期：2015.01.27
版本：V2.0
版权：星野传说的博客 http://blog.sina.com.cn/apex168

此版本修改档名称为 AN_vector_to_deformatio

v1.0 
使用方法：
工具=>组件轴向变形 启动插件后
先点击要轴向变形的组件，然后可依的两点间的距离，使组件X轴向变形于两点之间。
(鼠标右键)重选组件、（ESC）退出

v2.0 
使用方法及新增功能：
工具=>组件轴向变形 启动插件后
先点击要轴向变形的组件，然后可依的两点间的距离，使组件轴向变形于两点之间。
增加以下功能
Ctrl键==>改变组或组件变形轴向
VCB ==>可输入其它轴向比例值，输入后按Enter(确定)
鼠标右键==>重选组或组件
ESC==>退出。
输入比例值或变更的轴向增加记忆功能，于下次开启SketchUp时为上次设定。

提醒：任何使用、复制、修变和分发本插件，不得使用于商业用途。并注明出处。
# ------------------------------------------------------ #
=end
module AN_Hoshino_TOOL
  module HoshinoTOOL
	class AN_vector_to_deformatio
		def initialize#==============================================================初始化开始
			@mod=Sketchup.active_model#----------------------------------------------回传所有活动中的模型
			@ent=@mod.active_entities#-----------------------------------------------回传所有活动中的实体
			@sel=@mod.selection#-----------------------------------------------------选择对的选择
			@ip=Sketchup::InputPoint.new#--------------------------------------------输入新点
			self.reset#--------------------------------------------------------------自动复位
		end #========================================================================初始化结束
		
		def reset #==================================================================重新设置
		    @xyzmame =nil
			@segments=nil
			xyzmame  = Sketchup.read_default('anvectortodeformation', 'xyzmame')
			segments = Sketchup.read_default('anvectortodeformation', 'segments')
			@xyzmame  = xyzmame.to_s  unless xyzmame==nil
			@segments = segments.to_f unless segments==nil
			@xyzmame ="X"  if not @xyzmame #---------------------------------轴向       (预先定义 "x")
			@segments= 1.0 unless @segments #--------------------------------XY缩放比例 (预先定义 "固定")
			@status_text = "轴向变形：点击选取组或组件复制。    Ctrl(改轴向)，VCB(比例值)Ent(确定)，（ESC）退出。"#------------状态文本
			@status = 0 #----------------------------------------------------status==0
		end #========================================================================重新设置结束
		
		def an_vector_toss(ent,pt1,pt2,xyzaxis,xysca)#ent=组件的实例，pt1=第一点，pt2=第二点，xyzaxis=轴向，xysca=y轴比例
		 v2=pt1.vector_to pt2#---------------------------------------------V2回传 第一点到第二点的向量(轴向)
		 dist = pt1.distance (pt2)#----------------------------------------两点距离
		 pt = ent.transformation.origin#-----------------------------------(原点)
		 t=ent.transformation#---------------------------------------------t=回传转化
	        if xyzaxis==1
			 defnht=ent.bounds.max.x-ent.bounds.min.x #------------------------defnht回传新组件x轴最大x至最少x距离
			 x=dist/defnht#----------------------------------------------------两点距离除以组件距离
			 ent.transformation=Geom::Transformation.scaling(x,xysca,xysca)*t#---转化组件X轴比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(轴向)
			 myx = ent.transformation.xaxis#-----------------------------------组件y轴向
			 myy = ent.transformation.yaxis#-----------------------------------组件y轴向
			 myz = ent.transformation.zaxis#-----------------------------------组件Z轴向
			 fangle = myy.angle_between(myz)#----------------------------------y轴和Z轴角度
			 ent.transform! Geom::Transformation.new(pt1,myy,-fangle)#---------以y轴为轴心旋转
			 ent.transform! Geom::Transformation.new(pt1,myz,-fangle)#----------以y轴为轴心旋转
			 end
			 if xyzaxis==2
			 defnht=ent.bounds.max.y-ent.bounds.min.y #------------------------defnht回传新组件x轴最大x至最少x距离
			 x=dist/defnht#----------------------------------------------------两点距离除以组件距离
			 ent.transformation=Geom::Transformation.scaling(xysca,x,xysca)*t#---转化组件X轴比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(轴向)
			 myx = ent.transformation.xaxis#-----------------------------------组件x轴向
			 myy = ent.transformation.yaxis#-----------------------------------组件y轴向
			 myz = ent.transformation.zaxis#-----------------------------------组件Z轴向
			 fangle = myy.angle_between(myz)#----------------------------------y轴和Z轴角度
			 ent.transform! Geom::Transformation.new(pt1,myx,fangle)#---------以x轴为轴心旋转
			 ent.transform! Geom::Transformation.new(pt1,myz,fangle*2)#---------以y轴为轴心旋转
			end
			if xyzaxis==3
 			 defnht=ent.bounds.max.z-ent.bounds.min.z #------------------------defnht回传新组件x轴最大x至最少x距离
			 x=dist/defnht#----------------------------------------------------两点距离除以组件距离
			 ent.transformation=Geom::Transformation.scaling(xysca,xysca,x)*t#---转化组件X轴比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(轴向)
			 end
		 ent
		end
		
		def onMouseMove(flags, x, y, view) #=========================================鼠标在移动
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh#-------------应该是选择组件的z轴点
			Sketchup::set_status_text @status_text#----------------------------------SketchUp的设置状态文本状态的文字
			Sketchup::set_status_text("#{@segments}", SB_VCB_VALUE)
			Sketchup::set_status_text(@xyzmame+"轴，其它轴比例：", SB_VCB_LABEL)
			if @status==2
			 @target_point = @ip#----------------------------------------@target_point回传<<位置第二点>>
			 v03 = @first_point.distance (@target_point)#----------------------------------------两点距离
			    if v03>0.4
			        if @stnats==1
			         Sketchup.undo
					end
			     @mod.start_operation "轴向变形"#-------------------------------------模型开始操作"添加对齐组件"
				 tr=Geom::Transformation.new([0, 0, 0])#----------------------------------TR回传 几何图形新的组件定义
				 comp_copy=@ent.add_instance(@comp.definition,tr)#------------------------复制添加实例
				    if @xyzmame=="X"
					 an_vector_toss(comp_copy,@first_point,@target_point,1,@segments)
				    end
					if @xyzmame=="Y"
					 an_vector_toss(comp_copy,@first_point,@target_point,2,@segments)
					end
					if @xyzmame=="Z"
 					 an_vector_toss(comp_copy,@first_point,@target_point,3,@segments)
					end
				 @stnats=1
				end
			end
		end#=========================================================================鼠标在移动结束
		
		def onLButtonDown(flags, x, y, view)#========================================<<主程序>>
			ph = view.pick_helper; ph.do_pick x,y; best=ph.best_picked#--------------pH =视图拾取助手；pH=X，best=点击选取的实例
			if @status==0 #----------------------------------------------------------判断status==0<<没选组件>>
				if best.is_a?(Sketchup::ComponentInstance)or best.is_a?(Sketchup::Group)#--判断为组件或者组件(!best.kind_of? Sketchup::ComponentInstance or Sketchup::Group)
					@comp = best#----------------------------------------------------@comp回传为组件
					@status_text = "轴向变形：第一点。    Ctrl(改轴向)，VCB(比例值)Ent(确定)，鼠标右键(重选)，（ESC）退出。"#-----状态文本
					@status = 1#-----------------------------------------------------回传status==1
					@stnats=nil
				else #---------------------------------------------------------------其它
					UI.beep #--------------------------------------------------------发出声响
				end #----------------------------------------------------------------判断status==0<<没选组件>>结束
			elsif @status==1#--------------------------------------------------------判断status==0<<选组件后>>
			    if @stnats==1 and @status==1
				 @stnats=0
				 Sketchup.undo
				end
				@first_point = @ip.position#-----------------------------------------@first_point回传<<位置第一点>>
				@status_text = "轴向变形：点击第二点。    Ctrl(改轴向)，VCB(比例值)Ent(确定)，鼠标右键(重选)，（ESC）退出。"#---------状态文本
				@status = 2#---------------------------------------------------------回传status==2
			elsif @status==2#--------------------------------------------------------判断status==0<<位置第一点后>>
				@target_point = @ip.position#----------------------------------------@target_point回传<<位置第二点>>
				@mod.start_operation "轴向变形"#-------------------------------------模型开始操作"添加对齐组件"
				tr=Geom::Transformation.new([0, 0, 0])#----------------------------------TR回传 几何图形新的组件定义
				comp_copy=@ent.add_instance(@comp.definition,tr)#------------------------复制添加实例
				if @xyzmame=="X"
				  an_vector_toss(comp_copy,@first_point,@target_point,1,@segments)
				end
				if @xyzmame=="Y"
				  an_vector_toss(comp_copy,@first_point,@target_point,2,@segments)
				end
				if @xyzmame=="Z"
				  an_vector_toss(comp_copy,@first_point,@target_point,3,@segments)
				end
				#moveto(comp_copy, first_point)#-----------------------------------------移至第一点				
				#comp_copy.make_unique#--------------------------------------------------使为独立组件
				@mod.commit_operation#---------------------------------------------------模型提交操作
				@status_text = "轴向变形：第一点。    Ctrl(改轴向)，VCB(比例值)Ent(确定)，鼠标右键(重选)，（ESC）退出。"#------------状态文本
				@status = 1#-------------------------------------------------------------回传status==1
			end#-------------------------------------------------------------------------判断结束
		end#-----------------------------------------------------------------------------<<主程序>>结束
		
		def change_axis_up #Ctrl键(修改轴向)
 		    if @xyzmame =="X"
			 @xyzmame ="Y"
 		     Sketchup::set_status_text(@xyzmame+"轴，其它轴比例：", SB_VCB_LABEL)
			elsif @xyzmame =="Y"
			 @xyzmame ="Z"
			 Sketchup::set_status_text(@xyzmame+"轴，其它轴比例：", SB_VCB_LABEL)
			else @xyzmame =="Z"
  			 @xyzmame ="X"
			 Sketchup::set_status_text(@xyzmame+"轴，其它轴比例：", SB_VCB_LABEL)
			end
			Sketchup.write_default('anvectortodeformation', 'xyzmame', @xyzmame)
		end				
		
		def onKeyDown(key, repeat, flags, view)
		  case key
			 when COPY_MODIFIER_KEY then change_axis_up  #COPY_MODIFIER_KEY = Ctrl键(修改轴向)
			 end
		end
		
		def onRButtonDown(flags, x, y, view)#========================================(鼠标右键)
          @status > 0 ? self.reset : onCancel(flags,view)#-------------------------@status> 0 自复位取消标志查看
		end#=========================================================================(鼠标右键)结束
		
		def onCancel(flags,view)#====================================================取消
			Sketchup.send_action "selectSelectionTool:"#-----------------------------SketchUp的发送行为选择选择工具
			if @stnats==1
				 @stnats=0
				 Sketchup.undo
				end
		end#-------------------------------------------------------------------------结束
		
		
		def draw(view)#==============================================================画（视图）
			if( @ip.valid? && @ip.display? )#----------------------------------------如果 IP有效吗？IP显示
				@ip.draw(view)#------------------------------------------------------
			end
		end				

		def onUserText(text,view)# 在VCB修改比例值
		  begin
		     value = text.to_i
			 rescue
			 # 错误解析文本
			 UI.beep
			 value = nil
			 Sketchup::set_status_text "", SB_VCB_VALUE
			end
		  return if !value
		  @segments = value
		  Sketchup.write_default('anvectortodeformation', 'segments', "#{@segments.to_f.to_s}")
		end		
	end	
  end #Hoshino_TOOL
end #AN_Hoshino_TOOL

=begin
# ------------------  菜单设置 ---------------------- #
if(not $vector_to_deformatio_menu_loaded )
  UI.menu("Plugins").add_item("轴向变形"){ Sketchup.active_model.select_tool HoshinoTOOL::AN_key_roitx.new}
end
$vector_to_deformatio_menu_loaded = true 
=end

