=begin
# --------------------軸向變形---------------------- #
作者：星野傳說
檔案名稱：AN_vector_to_deformatio
中文名稱：軸向變形
日期：2015.01.27
版本：V2.0
版權：星野傳說的博客 http://blog.sina.com.cn/apex168

此版本修改檔名稱為 AN_vector_to_deformatio

v1.0 
使用方法：
工具=>元件軸向變形 啟動外掛程式後
先點擊要軸向變形的元件，然後可依的兩點間的距離，使元件X軸向變形於兩點之間。
(滑鼠右鍵)重選組件、（ESC）退出

v2.0 
使用方法及新增功能：
工具=>元件軸向變形 啟動外掛程式後
先點擊要軸向變形的元件，然後可依的兩點間的距離，使元件軸向變形於兩點之間。
增加以下功能
Ctrl鍵==>改變組或組件變形軸向
VCB ==>可輸入其它軸向比例值，輸入後按Enter(確定)
滑鼠右鍵==>重選組或組件
ESC==>退出。
輸入比例值或變更的軸向增加記憶功能，於下次開啟SketchUp時為上次設定。

提醒：任何使用、複製、修變和分發本外掛程式，不得使用於商業用途。並注明出處。
# ------------------------------------------------------ #
=end
module AN_Hoshino_TOOL
  module HoshinoTOOL
	class AN_vector_to_deformatio
		def initialize#==============================================================初始化開始
			@mod=Sketchup.active_model#----------------------------------------------回傳所有活動中的模型
			@ent=@mod.active_entities#-----------------------------------------------回傳所有活動中的實體
			@sel=@mod.selection#-----------------------------------------------------選擇對的選擇
			@ip=Sketchup::InputPoint.new#--------------------------------------------輸入新點
			self.reset#--------------------------------------------------------------自動復位
		end #========================================================================初始化結束
		
		def reset #==================================================================重新設置
		    @xyzmame =nil
			@segments=nil
			xyzmame  = Sketchup.read_default('anvectortodeformation', 'xyzmame')
			segments = Sketchup.read_default('anvectortodeformation', 'segments')
			@xyzmame  = xyzmame.to_s  unless xyzmame==nil
			@segments = segments.to_f unless segments==nil
			@xyzmame ="X"  if not @xyzmame #---------------------------------軸向       (預先定義 "x")
			@segments= 1.0 unless @segments #--------------------------------XY縮放比例 (預先定義 "固定")
			@status_text = "軸向變形：點擊選取組或組件複製。    Ctrl(改軸向)，VCB(比例值)Ent(確定)，（ESC）退出。"#------------狀態文本
			@status = 0 #----------------------------------------------------status==0
		end #========================================================================重新設置結束
		
		def an_vector_toss(ent,pt1,pt2,xyzaxis,xysca)#ent=組件的實例，pt1=第一點，pt2=第二點，xyzaxis=軸向，xysca=y軸比例
		 v2=pt1.vector_to pt2#---------------------------------------------V2回傳 第一點到第二點的向量(軸向)
		 dist = pt1.distance (pt2)#----------------------------------------兩點距離
		 pt = ent.transformation.origin#-----------------------------------(原點)
		 t=ent.transformation#---------------------------------------------t=回傳轉化
	        if xyzaxis==1
			 defnht=ent.bounds.max.x-ent.bounds.min.x #------------------------defnht回傳新組件x軸最大x至最少x距離
			 x=dist/defnht#----------------------------------------------------兩點距離除以組件距離
			 ent.transformation=Geom::Transformation.scaling(x,xysca,xysca)*t#---轉化組件X軸比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(軸向)
			 myx = ent.transformation.xaxis#-----------------------------------組件y軸向
			 myy = ent.transformation.yaxis#-----------------------------------組件y軸向
			 myz = ent.transformation.zaxis#-----------------------------------組件Z軸向
			 fangle = myy.angle_between(myz)#----------------------------------y軸和Z軸角度
			 ent.transform! Geom::Transformation.new(pt1,myy,-fangle)#---------以y軸為軸心旋轉
			 ent.transform! Geom::Transformation.new(pt1,myz,-fangle)#----------以y軸為軸心旋轉
			 end
			 if xyzaxis==2
			 defnht=ent.bounds.max.y-ent.bounds.min.y #------------------------defnht回傳新組件x軸最大x至最少x距離
			 x=dist/defnht#----------------------------------------------------兩點距離除以組件距離
			 ent.transformation=Geom::Transformation.scaling(xysca,x,xysca)*t#---轉化組件X軸比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(軸向)
			 myx = ent.transformation.xaxis#-----------------------------------組件x軸向
			 myy = ent.transformation.yaxis#-----------------------------------組件y軸向
			 myz = ent.transformation.zaxis#-----------------------------------組件Z軸向
			 fangle = myy.angle_between(myz)#----------------------------------y軸和Z軸角度
			 ent.transform! Geom::Transformation.new(pt1,myx,fangle)#---------以x軸為軸心旋轉
			 ent.transform! Geom::Transformation.new(pt1,myz,fangle*2)#---------以y軸為軸心旋轉
			end
			if xyzaxis==3
 			 defnht=ent.bounds.max.z-ent.bounds.min.z #------------------------defnht回傳新組件x軸最大x至最少x距離
			 x=dist/defnht#----------------------------------------------------兩點距離除以組件距離
			 ent.transformation=Geom::Transformation.scaling(xysca,xysca,x)*t#---轉化組件X軸比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(軸向)
			 end
		 ent
		end
		
		def onMouseMove(flags, x, y, view) #=========================================滑鼠在移動
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh#-------------應該是選擇組件的z軸點
			Sketchup::set_status_text @status_text#----------------------------------SketchUp的設置狀態文本狀態的文字
			Sketchup::set_status_text("#{@segments}", SB_VCB_VALUE)
			Sketchup::set_status_text(@xyzmame+"軸，其它軸比例：", SB_VCB_LABEL)
			if @status==2
			 @target_point = @ip#----------------------------------------@target_point回傳<<位置第二點>>
			 v03 = @first_point.distance (@target_point)#----------------------------------------兩點距離
			    if v03>0.4
			        if @stnats==1
			         Sketchup.undo
					end
			     @mod.start_operation "軸向變形"#-------------------------------------模型開始操作"添加對齊組件"
				 tr=Geom::Transformation.new([0, 0, 0])#----------------------------------TR回傳 幾何圖形新的組件定義
				 comp_copy=@ent.add_instance(@comp.definition,tr)#------------------------複製添加實例
				    if @xyzmame=="X"
					 an_vector_toss(comp_copy,@first_point,@target_point,1,@segments)
				    end
					if @xyzmame=="Y"
					 an_vector_toss(comp_copy,@first_point,@target_point,2,@segments)
					end
					if @xyzmame=="Z"
 					 an_vector_toss(comp_copy,@first_point,@target_point,3,@segments)
					end
				 @stnats=1
				end
			end
		end#=========================================================================滑鼠在移動結束
		
		def onLButtonDown(flags, x, y, view)#========================================<<主程序>>
			ph = view.pick_helper; ph.do_pick x,y; best=ph.best_picked#--------------pH =視圖拾取助手；pH=X，best=點擊選取的實例
			if @status==0 #----------------------------------------------------------判斷status==0<<沒選組件>>
				if best.is_a?(Sketchup::ComponentInstance)or best.is_a?(Sketchup::Group)#--判斷為元件或者元件(!best.kind_of? Sketchup::ComponentInstance or Sketchup::Group)
					@comp = best#----------------------------------------------------@comp回傳為組件
					@status_text = "軸向變形：第一點。    Ctrl(改軸向)，VCB(比例值)Ent(確定)，滑鼠右鍵(重選)，（ESC）退出。"#-----狀態文本
					@status = 1#-----------------------------------------------------回傳status==1
					@stnats=nil
				else #---------------------------------------------------------------其它
					UI.beep #--------------------------------------------------------發出聲響
				end #----------------------------------------------------------------判斷status==0<<沒選組件>>結束
			elsif @status==1#--------------------------------------------------------判斷status==0<<選組件後>>
			    if @stnats==1 and @status==1
				 @stnats=0
				 Sketchup.undo
				end
				@first_point = @ip.position#-----------------------------------------@first_point回傳<<位置第一點>>
				@status_text = "軸向變形：點擊第二點。    Ctrl(改軸向)，VCB(比例值)Ent(確定)，滑鼠右鍵(重選)，（ESC）退出。"#---------狀態文本
				@status = 2#---------------------------------------------------------回傳status==2
			elsif @status==2#--------------------------------------------------------判斷status==0<<位置第一點後>>
				@target_point = @ip.position#----------------------------------------@target_point回傳<<位置第二點>>
				@mod.start_operation "軸向變形"#-------------------------------------模型開始操作"添加對齊組件"
				tr=Geom::Transformation.new([0, 0, 0])#----------------------------------TR回傳 幾何圖形新的組件定義
				comp_copy=@ent.add_instance(@comp.definition,tr)#------------------------複製添加實例
				if @xyzmame=="X"
				  an_vector_toss(comp_copy,@first_point,@target_point,1,@segments)
				end
				if @xyzmame=="Y"
				  an_vector_toss(comp_copy,@first_point,@target_point,2,@segments)
				end
				if @xyzmame=="Z"
				  an_vector_toss(comp_copy,@first_point,@target_point,3,@segments)
				end
				#moveto(comp_copy, first_point)#-----------------------------------------移至第一點				
				#comp_copy.make_unique#--------------------------------------------------使為獨立組件
				@mod.commit_operation#---------------------------------------------------模型提交操作
				@status_text = "軸向變形：第一點。    Ctrl(改軸向)，VCB(比例值)Ent(確定)，滑鼠右鍵(重選)，（ESC）退出。"#------------狀態文本
				@status = 1#-------------------------------------------------------------回傳status==1
			end#-------------------------------------------------------------------------判斷結束
		end#-----------------------------------------------------------------------------<<主程序>>結束
		
		def change_axis_up #Ctrl鍵(修改軸向)
 		    if @xyzmame =="X"
			 @xyzmame ="Y"
 		     Sketchup::set_status_text(@xyzmame+"軸，其它軸比例：", SB_VCB_LABEL)
			elsif @xyzmame =="Y"
			 @xyzmame ="Z"
			 Sketchup::set_status_text(@xyzmame+"軸，其它軸比例：", SB_VCB_LABEL)
			else @xyzmame =="Z"
  			 @xyzmame ="X"
			 Sketchup::set_status_text(@xyzmame+"軸，其它軸比例：", SB_VCB_LABEL)
			end
			Sketchup.write_default('anvectortodeformation', 'xyzmame', @xyzmame)
		end				
		
		def onKeyDown(key, repeat, flags, view)
		  case key
			 when COPY_MODIFIER_KEY then change_axis_up  #COPY_MODIFIER_KEY = Ctrl鍵(修改軸向)
			 end
		end
		
		def onRButtonDown(flags, x, y, view)#========================================(滑鼠右鍵)
          @status > 0 ? self.reset : onCancel(flags,view)#-------------------------@status> 0 自重定取消標誌查看
		end#=========================================================================(滑鼠右鍵)結束
		
		def onCancel(flags,view)#====================================================取消
			Sketchup.send_action "selectSelectionTool:"#-----------------------------SketchUp的發送行為選擇選擇工具
			if @stnats==1
				 @stnats=0
				 Sketchup.undo
				end
		end#-------------------------------------------------------------------------結束
		
		
		def draw(view)#==============================================================畫（視圖）
			if( @ip.valid? && @ip.display? )#----------------------------------------如果 IP有效嗎？IP顯示
				@ip.draw(view)#------------------------------------------------------
			end
		end				

		def onUserText(text,view)# 在VCB修改比例值
		  begin
		     value = text.to_i
			 rescue
			 # 錯誤解析文本
			 UI.beep
			 value = nil
			 Sketchup::set_status_text "", SB_VCB_VALUE
			end
		  return if !value
		  @segments = value
		  Sketchup.write_default('anvectortodeformation', 'segments', "#{@segments.to_f.to_s}")
		end		
	end	
  end #Hoshino_TOOL
end #AN_Hoshino_TOOL

=begin
# ------------------  菜單設置 ---------------------- #
if(not $vector_to_deformatio_menu_loaded )
  UI.menu("Plugins").add_item("軸向變形"){ Sketchup.active_model.select_tool HoshinoTOOL::AN_key_roitx.new}
end
$vector_to_deformatio_menu_loaded = true 
=end

